﻿/***************************************************************************************************
* Website: www.warmforestflash.com
* Blog: www.warmforestflash.com/blog
* Email: hello@warmforestflash.com
* Feel free to use this code in any way you want other than selling it.
* Thanks. -Jay
***************************************************************************************************/

package
{
	import flash.display.*;
	import flash.text.*;
	import flash.events.*;
	import gs.TweenLite;
	import com.warmforestflash.ui.FullScreenScrollBar;
	
	public class Main extends Sprite
	{	
		private var _addCopyButton:Sprite;
		private var _paragraph:Sprite;
		private var _paragraphTextField:TextField;
		private var _copy:String;
		private var _scrollBar:FullScreenScrollBar;
		
		//============================================================================================================================
		public function Main()
		//============================================================================================================================
		{
			addEventListener(Event.ADDED_TO_STAGE, onAddedToStage, false, 0, true);
		}
		
		//============================================================================================================================
		private function init():void
		//============================================================================================================================
		{
			_copy = "Lorem ipsum dolor sit amet, consectetur adipiscing elit. Pellentesque quam leo semper non sollicitudin in eleifend sit amet diam. ";  
			
			_addCopyButton = createAddCopyButton();
			_addCopyButton.x = 30;
			_addCopyButton.y = 30;
			addChild(_addCopyButton);
			
			_paragraph = createParagraph();
			_paragraph.x = 110;
			_paragraph.y = 29;
			addChild(_paragraph);
			
			for(var i:int = 0; i < 20; i++)
			{
				_paragraphTextField.htmlText += _copy;
			}
			
			//************************************
			// Scrollbar code
			// Arguments: Content to scroll, track color, grabber color, grabber press color, grip color, track thickness, grabber thickness, ease amount, whether grabber is "shiny"
			//************************************
			_scrollBar = new FullScreenScrollBar(_paragraph, 0x222222, 0xff4400, 0x05b59a, 0xffffff, 15, 15, 4, true);
			addChild(_scrollBar);
		}
		
		//============================================================================================================================
		private function onAddedToStage(e:Event):void
		//============================================================================================================================
		{
			removeEventListener(Event.ADDED_TO_STAGE, onAddedToStage);
			init();
		}
		
		//============================================================================================================================
		private function createAddCopyButton():Sprite
		//============================================================================================================================
		{
			var s:Sprite = new Sprite();
			var font:Font = new Helvetica();
			var tf:TextFormat = new TextFormat();
			tf.font = font.fontName;
			tf.size = 11;
			tf.color = 0xffffff;
			var t:TextField = new TextField();
			t.autoSize = TextFieldAutoSize.LEFT;
			t.defaultTextFormat = tf;
			t.embedFonts = true;
			t.selectable = false;
			t.antiAliasType = AntiAliasType.ADVANCED;
			t.text = "Add Copy";
			t.x = 2;
			t.y = 3;
			
			var bg:Sprite = new Sprite();
			bg.graphics.beginFill(0xff4400);
			bg.graphics.drawRect(0, 0, 56, 18);
			bg.graphics.endFill();
			bg.name = "bg";
			
			s.buttonMode = true;
			s.mouseChildren = false;
			s.addEventListener(MouseEvent.CLICK, onAddCopyClick, false, 0, true);
			s.addEventListener(MouseEvent.ROLL_OVER, onAddCopyButtonRollOver, false, 0, true);
			s.addEventListener(MouseEvent.ROLL_OUT, onAddCopyButtonRollOut, false, 0, true);
			s.addChild(bg);
			s.addChild(t);
			return s;
		}
		
		//============================================================================================================================
		private function createParagraph():Sprite
		//============================================================================================================================
		{
			var s:Sprite = new Sprite();
			var font:Font = new Helvetica();
			var tf:TextFormat = new TextFormat();
			tf.font = font.fontName;
			tf.size = 12;
			tf.color = 0xffffff;
			tf.leading = 4;
			_paragraphTextField = new TextField();
			_paragraphTextField.width = 440;
			_paragraphTextField.autoSize = TextFieldAutoSize.LEFT;
			_paragraphTextField.wordWrap = true;
			_paragraphTextField.defaultTextFormat = tf;
			_paragraphTextField.antiAliasType = AntiAliasType.ADVANCED;
			_paragraphTextField.embedFonts = true;
			_paragraphTextField.selectable = false;
			s.addChild(_paragraphTextField);
			return s;
		}
		
		//============================================================================================================================
		private function onAddCopyClick(e:MouseEvent):void
		//============================================================================================================================
		{
			_paragraphTextField.htmlText += _copy;
			_scrollBar.adjustSize();
		}
		
		//============================================================================================================================
		private function onAddCopyButtonRollOver(e:MouseEvent):void
		//============================================================================================================================
		{
			TweenLite.to(e.target.getChildByName("bg"), 0.5, {tint:0x05b59a});
		}
		
		//============================================================================================================================
		private function onAddCopyButtonRollOut(e:MouseEvent):void
		//============================================================================================================================
		{
			TweenLite.to(e.target.getChildByName("bg"), 0.5, {tint:null});
		}
		
	}
}